%main Loop
tic
clear;
NumSim = 100;



% define structure of parameter values that control DGP
Param.azeta     = -.1;
Param.a0        = 1;
Param.kappa     = 20;
Param.ku        = 1;
Param.ka        = 10;
Param.d         = 1;
Param.betaz     = ones(Param.d,1);
Param.betazbar  = []; 
outfn           ='Results_GMM_h_n100_loc5.txt';

Param.n         = []; % sample size


lambda_list  = [.1,.5,.7];        % parameter values for network interaction
localToNonID = [.5,.3,.1];     % parameter that controls identification of linear IV
%localToNonID = [0];     % parameter that controls identification of linear IV
%amu_list     = [0,-.1];             % network endogeneity parameter
amu_list     = [-.1];             % network endogeneity parameter
%n_list       = [100,250,500];
n_list       = [100];

Results      = EvaluateSimulations(NumSim,outfn,true);
for in = 1:length(n_list)
    Param.n  = n_list(in);
    for i3 = 1:length(amu_list)
        Param.amu = amu_list(i3);
        for i1 = 1:length(lambda_list)
            Param.lambda = lambda_list(i1);
            for i2 = 1:length(localToNonID)
                Param.LocalID  = localToNonID(i2);
                Param.betazbar = - (Param.lambda + localToNonID(i2))*Param.betaz;
       %        Param.betazbar = 0;
                Results      = EvaluateSimulations(NumSim,outfn,false);
                rng(0);            % Initialize random number generators for predictable rndn sequences
                for i=1:NumSim
                    y = SimulateGI(Param); % generates data object with randomly drawn samples Goldsmith Imbens model
                    y.OLS;
                    Results.CompMSE(y,true);
                    y.IV;
                    Results.CompMSE(y,false);
                    y.IVA;
                    Results.CompMSE(y,false);                
                    y.GMM;
                    Results.CompMSE(y,false);
                end
                Results.AveMSE(y);
            end
        end
    end
end
toc
    
